/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Tramo;
import com.rjconsultores.ventaboletos.entidad.Via;
import com.rjconsultores.ventaboletos.service.ViaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTramo;

/**
 * 
 * @author Administrador
 */
@Controller("busquedaTramosController")
@Scope("prototype")
public class BusquedaTramosController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<Tramo> plwTramos;
	@Autowired
	private ViaService viaService;
	private MyListbox tramosList;
	private Paging pagingTramos;
	private Textbox txtNome;
	private Combobox cmbParadaOrigem;
	private Combobox cmbParadaDestino;
	private Combobox cmbVia;
	private Intbox txtKmReal;
	private List<Via> lsVias;

	public List<Via> getLsVias() {
		return lsVias;
	}

	public void setLsVias(List<Via> lsVias) {
		this.lsVias = lsVias;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		lsVias = viaService.obtenerTodos();

		tramosList.setItemRenderer(new RenderTramo());
		tramosList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				Tramo c = (Tramo) tramosList.getSelected();
				verTramos(c);
			}
		});

		refreshLista();

		txtNome.focus();
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	private void verTramos(Tramo t) {
		if (t == null) {
			return;
		}

		Map args = new HashMap();
		args.put("tramo", t);
		args.put("tramosList", tramosList);

		openWindow("/gui/esquema_operacional/editarTramos.zul",
				Labels.getLabel("editarTramosController.window.title"), args, MODAL);
	}

	private void refreshLista() {
		HibernateSearchObject<Tramo> tramoBusqueda =
				new HibernateSearchObject<Tramo>(Tramo.class, pagingTramos.getPageSize());

		tramoBusqueda.addFilterLike("desctramo", "%" + txtNome.getText().trim().concat("%"));

		Comboitem cbiOrigem = cmbParadaOrigem.getSelectedItem();
		if (cbiOrigem != null) {
			Parada origem = (Parada) cbiOrigem.getValue();
			tramoBusqueda.addFilterEqual("origem", origem);
		}

		Comboitem cbiDestino = cmbParadaDestino.getSelectedItem();
		if (cbiDestino != null) {
			Parada destino = (Parada) cbiDestino.getValue();
			tramoBusqueda.addFilterEqual("destino", destino);
		}

		Comboitem cbiVia = cmbVia.getSelectedItem();
		if (cbiVia != null) {
			Via via = (Via) cbiVia.getValue();
			tramoBusqueda.addFilterEqual("via", via);
		}

		tramoBusqueda.addFilterEqual("kmReal", txtKmReal.getValue());

		tramoBusqueda.addSortAsc("desctramo");
		tramoBusqueda.addFilterEqual("activo", Boolean.TRUE);

		plwTramos.init(tramoBusqueda, tramosList, pagingTramos);

		if (tramosList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaTramosController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	public void onClick$btnPesquisa(Event ev) {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verTramos(new Tramo());
	}
}
